#ifndef __GLOBAL_H_
#define __GLOBAL_H_

// -- definitions --

extern const TCHAR *szwaGenScriptingWindowClass;
extern const TCHAR *szwagsReplyWindowClass;

#define WAGS_PROTOCOL_VERSION 1

#pragma warning(disable: 4200)

typedef struct _wagscdmsg
{
	DWORD	dwProtocolVersion;
	HWND	hwndReply;
	DWORD	dwFunction;
	LPARAM	lparam;
	WPARAM	wparam;
	DWORD	dwDataSize;
	BYTE	data[0];
} wagscsMsg;

#pragma warning(default: 4200)


// Default size for fixed-size buffers
#define BUFFERSIZE 4096

// -- utility functions --

namespace LeoDavidsonUtils
{
	// delete[] the result.
	// Returns NULL on failure.
	TCHAR *StringAllocAndFormat(const TCHAR *format, ...);

	// delete[] the result.
	// Returns NULL on failure.
	TCHAR *VStringAllocAndFormat(const TCHAR *format, va_list args);

	// Returns NULL on failure (use GetLastError())
	// delete[] the result when finished with it.
	WCHAR *LeetMBtoWC(const char *mbString);

	// Returns NULL on failure (use GetLastError())
	// delete[] the result when finished with it.
	char *LeetWCtoMB(const WCHAR *wcString);

	std::wstring LeetMBtoWCString(const char *mbString);
	std::string  LeetWCtoMBString(const WCHAR *wcString);
};

#endif
